"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_1 = require("@amaui/style");
const AmauiThemeContext_1 = __importDefault(require("./AmauiThemeContext"));
const useAmauiTheme_1 = __importDefault(require("./useAmauiTheme"));
const resolveValue = (value) => {
    const toFilterOut = ['id', 'element'];
    const valueNew = {};
    Object.keys(value).filter(item => toFilterOut.indexOf(item) === -1).forEach(item => valueNew[item] = value[item]);
    return valueNew;
};
function AmauiThemeProvider(props) {
    const { children, value: valueLocal = {} } = props, other = __rest(props, ["children", "value"]);
    const ref = react_1.default.useRef();
    const valueParent = (0, useAmauiTheme_1.default)() || {};
    const [value, setValue] = react_1.default.useState(() => new style_1.AmauiTheme((0, utils_1.merge)((0, utils_1.copy)(resolveValue(Object.assign({}, valueLocal))), (0, utils_1.copy)(resolveValue(Object.assign({}, valueParent))), { copy: true })));
    react_1.default.useEffect(() => {
        if (ref.current) {
            const amauiTheme = new style_1.AmauiTheme(value, ref.current);
            amauiTheme.id = value.id;
            // Init
            setValue(amauiTheme);
        }
    }, []);
    react_1.default.useEffect(() => {
        value.update((0, utils_1.merge)((0, utils_1.copy)(resolveValue(Object.assign({}, valueLocal))), (0, utils_1.copy)(resolveValue(Object.assign({}, valueParent))), { copy: true }));
        const amauiTheme = new style_1.AmauiTheme(value, ref.current);
        amauiTheme.id = value.id;
        // Init
        setValue(amauiTheme);
    }, [(0, utils_1.hash)(resolveValue(valueLocal)), (0, utils_1.hash)(resolveValue(valueParent))]);
    const update = (updateValue) => {
        if (updateValue !== undefined) {
            // Update
            value.update(updateValue);
            const amauiTheme = new style_1.AmauiTheme(value, ref.current);
            amauiTheme.id = value.id;
            // Init
            setValue(amauiTheme);
            return value;
        }
    };
    // Update method
    value.updateWithRerender = update;
    return (react_1.default.createElement(AmauiThemeContext_1.default.Provider, { value: value },
        react_1.default.createElement("div", Object.assign({ ref: ref }, other), children)));
}
exports.default = AmauiThemeProvider;
