import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
const _excluded = ["children", "value"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import React from 'react';
import { merge, copy, hash } from '@amaui/utils';
import { AmauiTheme } from '@amaui/style';
import AmauiThemeContext from './AmauiThemeContext';
import useAmauiTheme from './useAmauiTheme';

const resolveValue = value => {
  const toFilterOut = ['id', 'element'];
  const valueNew = {};
  Object.keys(value).filter(item => toFilterOut.indexOf(item) === -1).forEach(item => valueNew[item] = value[item]);
  return valueNew;
};

export default function AmauiThemeProvider(props) {
  const {
    children,
    value: valueLocal = {}
  } = props,
        other = _objectWithoutProperties(props, _excluded);

  const ref = React.useRef();
  const valueParent = useAmauiTheme() || {};
  const [value, setValue] = React.useState(() => new AmauiTheme(merge(copy(resolveValue(_objectSpread({}, valueLocal))), copy(resolveValue(_objectSpread({}, valueParent))), {
    copy: true
  })));
  React.useEffect(() => {
    if (ref.current) {
      const amauiTheme = new AmauiTheme(value, ref.current);
      amauiTheme.id = value.id; // Init

      setValue(amauiTheme);
    }
  }, []);
  React.useEffect(() => {
    value.update(merge(copy(resolveValue(_objectSpread({}, valueLocal))), copy(resolveValue(_objectSpread({}, valueParent))), {
      copy: true
    }));
    const amauiTheme = new AmauiTheme(value, ref.current);
    amauiTheme.id = value.id; // Init

    setValue(amauiTheme);
  }, [hash(resolveValue(valueLocal)), hash(resolveValue(valueParent))]);

  const update = updateValue => {
    if (updateValue !== undefined) {
      // Update
      value.update(updateValue);
      const amauiTheme = new AmauiTheme(value, ref.current);
      amauiTheme.id = value.id; // Init

      setValue(amauiTheme);
      return value;
    }
  }; // Update method


  value.updateWithRerender = update;
  return /*#__PURE__*/React.createElement(AmauiThemeContext.Provider, {
    value: value
  }, /*#__PURE__*/React.createElement("div", _extends({
    ref: ref
  }, other), children));
}