"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const utils_1 = require("@amaui/utils");
const style_1 = require("@amaui/style");
const _1 = require(".");
function reset(value = {}, options_ = {}) {
    let response;
    function useReset(props) {
        const [values, setValues] = react_1.default.useState({
            classes: {},
            classNames: {},
            keyframes: {},
            styles: () => { },
        });
        const amauiStyle = (0, _1.useAmauiStyle)();
        const amauiTheme = (0, _1.useAmauiTheme)();
        // Init only once
        // it has to be in body of method
        // as for ssr it actually calls the method
        // and it doesn't use hooks on ssr
        if (response === undefined) {
            const options = {
                amaui_style: { value: undefined },
                amaui_theme: { value: undefined },
            };
            // AmauiStyle
            if (amauiStyle !== undefined)
                options.amaui_style.value = amauiStyle;
            // AmauiTheme
            if (amauiTheme !== undefined)
                options.amaui_theme.value = amauiTheme;
            if (response === undefined)
                response = (0, style_1.reset)(value, (0, utils_1.merge)(options, options_, { copy: true }));
            // Update values for ssr as a priorty
            setValues((0, style_1.names)(response.amaui_style_sheet_manager.names));
        }
        // Add
        react_1.default.useEffect(() => {
            const addValues = response.add(props);
            setValues(addValues);
            // Updates for amauiTheme
            const method = () => {
                if ((0, utils_1.is)('function', value)) {
                    const valueNew = value(amauiTheme);
                    // Update
                    if ((response === null || response === void 0 ? void 0 : response.update) !== undefined)
                        response.update(valueNew);
                }
            };
            if (amauiTheme)
                amauiTheme.subscriptions.update.subscribe(method);
            // Clean up
            return () => {
                var _a;
                // Unsubscribe
                if (amauiTheme)
                    amauiTheme.subscriptions.update.unsubscribe(method);
                // Remove
                response.remove((_a = addValues.ids) === null || _a === void 0 ? void 0 : _a.dynamic);
            };
        }, []);
        // Update props
        react_1.default.useEffect(() => {
            if (response !== undefined && values.ids)
                response.props = { ids: values.ids.dynamic, props };
        }, [(0, utils_1.hash)(props)]);
        return values;
    }
    return useReset;
}
exports.default = reset;
