"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const style_1 = require("@amaui/style");
const _1 = require(".");
// May be TValue or a string  as a string value literal
function string(value_, ...args) {
    const [response, setResponse] = react_1.default.useState();
    const [values, setValues] = react_1.default.useState({
        classes: {},
        classNames: {},
        keyframes: {},
        styles: () => { },
    });
    const amauiStyle = (0, _1.useAmauiStyle)();
    const amauiTheme = (0, _1.useAmauiTheme)();
    const method = () => value_.reduce((result, item, index) => result += `${item}${args[index] || ''}`, '');
    const value = {
        a: method(),
    };
    let values_ = values;
    // Init only once
    // it has to be in body of method
    // as for ssr it actually calls the method
    // and it doesn't use hooks on ssr
    if (response === undefined) {
        const options = {
            amaui_style: { value: undefined },
            amaui_theme: { value: undefined },
        };
        // AmauiStyle
        if (amauiStyle !== undefined)
            options.amaui_style.value = amauiStyle;
        // AmauiTheme
        if (amauiTheme !== undefined)
            options.amaui_theme.value = amauiTheme;
        const response_ = (0, style_1.style)(value, options);
        setResponse(response_);
        // Update values for ssr as a priorty
        values_ = (0, style_1.names)(response_.amaui_style_sheet_manager.names);
        setValues(values_);
    }
    react_1.default.useEffect(() => {
        // Add
        const addValues = response.add();
        setValues(addValues);
        // Clean up
        return () => {
            var _a;
            // Remove
            response.remove((_a = addValues.ids) === null || _a === void 0 ? void 0 : _a.dynamic);
        };
    }, []);
    // Update
    // if values update based on
    // ui props or useAmauiTheme update
    react_1.default.useEffect(() => {
        if ((response === null || response === void 0 ? void 0 : response.update) !== undefined)
            response.update(value);
    }, [value.a]);
    return (values_.class || '');
}
exports.default = string;
