"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const _1 = require(".");
const withStyle = (Element) => (value, options = {}) => {
    // Use styles
    const useStyle = (0, _1.style)(value, options);
    // Element
    const element = react_1.default.forwardRef((props, ref) => {
        const styles = useStyle(props);
        return (react_1.default.createElement(Element, Object.assign({ ref: ref, styles: styles }, props)));
    });
    return element;
};
exports.default = withStyle;
